diff -ruN versions/nakedmudv3.6/src/olc2/olc_extender.c src/olc2/olc_extender.c
--- versions/nakedmudv3.6/src/olc2/olc_extender.c	1969-12-31 19:00:00.000000000 -0500
+++ src/olc2/olc_extender.c	2008-12-03 03:40:07.000000000 -0500
@@ -0,0 +1,282 @@
+//*****************************************************************************
+//
+// olc_extender.c
+//
+// A structure for helping in the extension of OLC functions. Allows for the
+// registration of new commands, menu displays, parsers, and execution 
+// functions.
+//
+//*****************************************************************************
+#include "../mud.h"
+#include "../socket.h"
+#include "olc.h"
+#include "olc_extender.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyplugs.h"
+
+
+
+//*****************************************************************************
+// local variables, structures, and functions
+//*****************************************************************************
+
+// what kind of extension is this?
+#define OLCEXT_C        0
+#define OLCEXT_PY       1
+
+// what is the minimum ID we use?
+#define MIN_CHOICE_ID   10000
+
+typedef struct olc_extender_data {
+  // what type of extension is this?
+  int type;
+
+  // C functions
+  void       (* menu)(SOCKET_DATA *sock, void *data);
+  int (* choose_exec)(SOCKET_DATA *sock, void *data);
+  bool (* parse_exec)(SOCKET_DATA *sock, void *data, const char *arg);
+  void (* from_proto)(void *data);
+  void   (* to_proto)(void *data, BUFFER *buf);
+
+  // Python functions
+  PyObject   *pymenu;
+  PyObject *pychoose;
+  PyObject  *pyparse;
+  PyObject *pyfrompr;
+  PyObject   *pytopr;
+} OLC_EXT_DATA;
+
+struct olc_extender {
+  HASHTABLE *opt_hash;
+  void *(* borrow_py)(void *data);
+};
+
+OLC_EXT_DATA *newOLCExt(void *menu, void *choose_exec, void *parse_exec,
+			void *from_proto, void *to_proto) {
+  OLC_EXT_DATA *ext = calloc(1, sizeof(OLC_EXT_DATA));
+  ext->menu         = menu;
+  ext->choose_exec  = choose_exec;
+  ext->parse_exec   = parse_exec;
+  ext->from_proto   = from_proto;
+  ext->to_proto     = to_proto;
+  ext->type = OLCEXT_C;
+  return ext;
+}
+
+OLC_EXT_DATA *newPyOLCExt(PyObject *menu, PyObject *choose_exec, 
+			  PyObject *parse_exec, PyObject *from_proto,
+			  PyObject *to_proto) {
+  OLC_EXT_DATA *ext = calloc(1, sizeof(OLC_EXT_DATA));
+  ext->pymenu   = menu;        Py_XINCREF(menu);
+  ext->pychoose = choose_exec; Py_XINCREF(choose_exec);
+  ext->pyparse  = parse_exec;  Py_XINCREF(parse_exec);
+  ext->pyfrompr = from_proto;  Py_XINCREF(from_proto);
+  ext->pytopr   = to_proto;    Py_XINCREF(to_proto);
+  ext->type = OLCEXT_PY;
+  return ext;
+}
+
+void deleteOLCExt(OLC_EXT_DATA *ext) {
+  Py_XDECREF(ext->pymenu);
+  Py_XDECREF(ext->pychoose);
+  Py_XDECREF(ext->pyparse);
+  Py_XDECREF(ext->pyfrompr);
+  Py_XDECREF(ext->pytopr);
+  free(ext);
+}
+
+
+
+//*****************************************************************************
+// implementation of olc_extender.h
+//*****************************************************************************
+OLC_EXTENDER *newExtender(void) {
+  OLC_EXTENDER *data = calloc(1, sizeof(OLC_EXTENDER));
+  data->opt_hash = newHashtable();
+  return data;
+}
+
+void extenderSetPyFunc(OLC_EXTENDER *ext, void *borrow_py) {
+  ext->borrow_py = borrow_py;
+}
+
+void extenderDoMenu(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data) {
+  LIST           *keys = hashCollect(ext->opt_hash);
+  char            *key = NULL;
+  OLC_EXT_DATA  *edata = NULL;
+
+  // display each menu item alphabetically
+  listSortWith(keys, strcasecmp);
+  LIST_ITERATOR *key_i = newListIterator(keys);
+  ITERATE_LIST(key, key_i) {
+    // display the menu option
+    send_to_socket(sock, "{g%s) ", key);
+
+    // then display the information
+    edata = hashGet(ext->opt_hash, key);
+    if(edata->type == OLCEXT_C)
+      edata->menu(sock, data);
+    else if(ext->borrow_py != NULL) {
+      PyObject *ret = PyObject_CallFunction(edata->pychoose, "OO", 
+					    socketGetPyFormBorrowed(sock), 
+					    ext->borrow_py(data));
+      if(ret == NULL)
+	log_pyerr("Error running Python OLC exention menu function: %s", key);
+      Py_XDECREF(ret);
+    }
+  } deleteListIterator(key_i);
+
+  // free up our garbage
+  deleteListWith(keys, free);
+}
+
+int extenderDoOptChoice(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data, 
+			char opt) {
+  char key[2] = { opt, '\0' };
+
+  // does it exist?
+  if(!hashIn(ext->opt_hash, key))
+    return MENU_CHOICE_INVALID;
+
+  // pull out the data
+  OLC_EXT_DATA *edata = hashGet(ext->opt_hash, key);
+  int          retval = MENU_CHOICE_INVALID;
+
+  // is it C data or Python data?
+  if(edata->type == OLCEXT_C)
+    retval = edata->choose_exec(sock, data);
+  else if(ext->borrow_py != NULL) {
+    PyObject *ret = 
+      PyObject_CallFunction(edata->pychoose, "O", ext->borrow_py(data));
+    if(ret == NULL)
+      log_pyerr("Error running Python OLC exention choice function: %s", key);
+    else if(PyInt_Check(ret))
+      retval = (int)PyInt_AsLong(ret);
+    Py_XDECREF(ret);
+  }
+
+  // did we do a toggle, or enter a submenu?
+  if(retval == MENU_NOCHOICE || retval == MENU_CHOICE_INVALID)
+    return retval;
+  return MIN_CHOICE_ID + opt;
+}
+
+bool extenderDoParse(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data, 
+		     int choice, const char *arg) {
+  char key[2] = { (char)(choice - MIN_CHOICE_ID), '\0' };
+
+  // pull out the data
+  OLC_EXT_DATA *edata = hashGet(ext->opt_hash, key);
+  int          retval = FALSE;
+
+  // is it C data or Python data?
+  if(edata->type == OLCEXT_C)
+    retval = edata->parse_exec(sock, data, arg);
+  else if(ext->borrow_py != NULL) {
+    PyObject *pyret = 
+      PyObject_CallFunction(edata->pyparse, "Os", ext->borrow_py(data), arg);
+    if(pyret == NULL)
+      log_pyerr("Error running Python OLC exention parse function: %s", key);
+    else if(PyObject_IsTrue(pyret))
+      retval = TRUE;
+    Py_XDECREF(pyret);
+  }
+
+  // was it valid?
+  return retval;
+}
+
+void extenderToProto(OLC_EXTENDER *ext, void *data, BUFFER *buf) {
+  LIST           *keys = hashCollect(ext->opt_hash);
+  char            *key = NULL;
+  OLC_EXT_DATA  *edata = NULL;
+
+  // display each menu item alphabetically
+  listSortWith(keys, strcasecmp);
+  LIST_ITERATOR *key_i = newListIterator(keys);
+  ITERATE_LIST(key, key_i) {
+    edata = hashGet(ext->opt_hash, key);
+
+    // is it C data?
+    if(edata->type == OLCEXT_C) {
+      if(edata->to_proto != NULL)
+	edata->to_proto(data, buf);
+    }
+    // is it Python data?
+    else if(ext->borrow_py != NULL) {
+      if(edata->pytopr != NULL && edata->pytopr != Py_None) {
+	PyObject *ret = PyObject_CallFunction(edata->pytopr, "O",
+					      ext->borrow_py(data));
+	if(ret == NULL)
+	  log_pyerr("Error running Python OLC to_proto function: %s", key);
+	else
+	  bufferCat(buf, PyString_AsString(ret));
+	Py_XDECREF(ret);
+      }
+    }
+  } deleteListIterator(key_i);
+
+  // free up our garbage
+  deleteListWith(keys, free);
+}
+
+void extenderFromProto(OLC_EXTENDER *ext, void *data) {
+  LIST           *keys = hashCollect(ext->opt_hash);
+  char            *key = NULL;
+  OLC_EXT_DATA  *edata = NULL;
+
+  // display each menu item alphabetically
+  listSortWith(keys, strcasecmp);
+  LIST_ITERATOR *key_i = newListIterator(keys);
+  ITERATE_LIST(key, key_i) {
+    edata = hashGet(ext->opt_hash, key);
+
+    // is it C data?
+    if(edata->type == OLCEXT_C) {
+      if(edata->from_proto != NULL)
+	edata->from_proto(data);
+    }
+    // is it Python data?
+    else if(ext->borrow_py != NULL) {
+      if(edata->pyfrompr != NULL && edata->pyfrompr != Py_None) {
+	PyObject *ret = PyObject_CallFunction(edata->pyfrompr, "O",
+					      ext->borrow_py(data));
+	if(ret == NULL)
+	  log_pyerr("Error running Python OLC from_proto function: %s", key);
+	Py_XDECREF(ret);
+      }
+    }
+  } deleteListIterator(key_i);
+
+  // free up our garbage
+  deleteListWith(keys, free);
+}
+
+void gen_register_opt(OLC_EXTENDER *ext, char opt, OLC_EXT_DATA *data) {
+  char key[2] = { opt, '\0' };
+
+  // do we already have this registered? If so, clear it
+  if(hashIn(ext->opt_hash, key))
+    deleteOLCExt(hashRemove(ext->opt_hash, key));
+  hashPut(ext->opt_hash, key, data);
+}
+
+void extenderRegisterOpt(OLC_EXTENDER *ext, char opt, 
+			 void *menu, void *choice, void *parse, 
+			 void *from_proto, void *to_proto) {
+  gen_register_opt(ext, opt, newOLCExt(menu,choice,parse,from_proto,to_proto));
+}
+
+//
+// The same, but takes Python functions instead of C function
+void extenderRegisterPyOpt(OLC_EXTENDER *ext, char opt, 
+			   void *menu, void *choice, void *parse,
+			   void *from_proto, void *to_proto) {
+  gen_register_opt(ext,opt,newPyOLCExt(menu,choice,parse,from_proto,to_proto));
+}
diff -ruN versions/nakedmudv3.6/src/olc2/olc_extender.h src/olc2/olc_extender.h
--- versions/nakedmudv3.6/src/olc2/olc_extender.h	1969-12-31 19:00:00.000000000 -0500
+++ src/olc2/olc_extender.h	2008-12-03 03:17:25.000000000 -0500
@@ -0,0 +1,94 @@
+#ifndef OLC_EXTENDER_H
+#define OLC_EXTENDER_H
+//*****************************************************************************
+//
+// olc_extender.h
+//
+// A structure for helping in the extension of OLC functions. Allows for the
+// registration of new commands, menu displays, parsers, and execution 
+// functions.
+//
+//*****************************************************************************
+
+typedef struct olc_extender OLC_EXTENDER;
+
+// various extenders we might want to add to
+extern OLC_EXTENDER *medit_extend;
+extern OLC_EXTENDER *redit_extend;
+extern OLC_EXTENDER *oedit_extend;
+
+//
+// Create a new OLC extender
+OLC_EXTENDER *newExtender(void);
+
+//
+// Set the function that convert's the OLC's datatype to a borrowed Python 
+// object, so Python extensions can also be registered
+void extenderSetPyFunc(OLC_EXTENDER *ext, void *borrow_py);
+
+//
+// shows all of the menu options in the extender
+void extenderDoMenu(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data);
+
+//
+// If the option does not exist, return MENU_CHOICE_INVALID.
+// If the option leads to a submenu or a toggle, return MENU_NOCHOICE.
+// Otherwise, return a unique identifier in the range of 10000 and 11000
+int extenderDoOptChoice(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data, 
+			char opt);
+
+//
+// Run the parse function for the extender wit hthe specified choice ID.
+// Return TRUE if it is successful, or FALSE otherwise
+bool extenderDoParse(SOCKET_DATA *sock, OLC_EXTENDER *ext, void *data, 
+		     int choice, const char *arg);
+
+//
+// run all of our toProto functions
+void extenderToProto(OLC_EXTENDER *ext, void *data, BUFFER *buf);
+
+//
+// run all of our from proto functions
+void extenderFromProto(OLC_EXTENDER *ext, void *data);
+
+//
+// Set up a new OLC extension. Allows for extensions to the menu, functions
+// that execute on making a menu choice, and functions that parse arguments
+// for menu choices:
+//
+// menu: This is the function that displays the OLC menu to the socket:
+//       void menu(SOCKET_DATA *sock, datatype *to_display)
+//
+// choice_exec: This function executes when the extension is chosen from the
+//       OLC menu. Return MENU_NOCHOICE if this is a toggle, or if a new
+//       OLC or input handler is pushed. Return MENU_CHOICE_OK otherwise.
+//       int choice_exec(SOCKET_DATA *sock, datatype *to_edit)
+//
+// parse_exec: This function executes when the extension has been chosen, and
+//       an argument needs to be parsed. Return TRUE if is was parsed, and
+//       FALSE otherwise
+//       bool parse_exec(SOCKET_DATA *sock, datatype *to_edit, const char *arg)
+//
+// from_proto: This function does neccessary stuff to the data itself when a
+//       when an OLC object has just been created from a prototype. Mainly, this
+//       is for properly formatting buffered descriptions. Not neccessary if
+//       the extender is not for something that comes from a prototype
+//       (i.e., mobs, objs, and rooms)
+//       void from_proto(datatype *to_edit)
+//
+//  to_proto: This function converts the data to a Python script for generating
+//       it. Not neccesary if the extender is not for something that comes from
+//       a prototype.
+//       void to_proto(datatype *to_convert, BUFFER *destination)
+void extenderRegisterOpt(OLC_EXTENDER *ext, char opt, 
+			 void *menu, void *choice, void *parse,
+			 void *from_proto, void *to_proto);
+
+//
+// The same, but takes Python functions instead of C function. to_proto will
+// return a string instead of concatting it to a buffer.
+void extenderRegisterPyOpt(OLC_EXTENDER *ext, char opt, 
+			   void *menu, void *choice, void *parse,
+			   void *from_proto, void *to_proto);
+
+#endif // OLC_EXTENDER_H
diff -ruN versions/nakedmudv3.6/src/olc2/redit.c src/olc2/redit.c
--- versions/nakedmudv3.6/src/olc2/redit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/olc2/redit.c	2008-12-03 15:19:59.000000000 -0500
@@ -25,6 +25,7 @@
 
 #include "olc.h"
 #include "olc_submenus.h"
+#include "olc_extender.h"
 
 
 
@@ -766,7 +767,6 @@
   } while(*code != '\0');
 }
 
-
 ROOM_OLC *roomOLCFromProto(PROTO_DATA *proto) {
   ROOM_OLC  *data = newRoomOLC();
   ROOM_DATA *room = roomOLCGetRoom(data);
@@ -774,97 +774,35 @@
   roomOLCSetParents(data, protoGetParents(proto));
   roomOLCSetAbstract(data, protoIsAbstract(proto));
 
-  // this is a really ugly way to do the conversion, but basically let's
-  // just look through every line in the buffer and if we recognize some
-  // token, parse out whatever is assigned to it
-  char line[MAX_BUFFER];
-  const char *code = protoGetScript(proto);
-  do {
-    code = strcpyto(line, code, '\n');
-    char *lptr = line;
-    if(!strncmp(lptr, "me.name", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      roomSetName(room, lptr);
-    }
-    else if(!strncmp(lptr, "me.desc",  7)) {
-      // we have three "'s to skip by, because this lptr will take the form:
-      // me.desc = me.desc + " " + "..."
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      roomSetDesc(room, lptr);
-      // replace our \"s with "
-      bufferReplace(roomGetDescBuffer(room), "\\\"", "\"", TRUE);
-      bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
-    }
-    else if(!strncmp(lptr, "me.terrain", 10)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                      // kill the leading "
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      roomSetTerrain(room, terrainGetNum(lptr));
-    }
-    else if(!strncmp(lptr, "me.edesc(", 9)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                              // kill the leading "
-      char *desc_start = lptr + next_letter_in(lptr, '\"') + 1;
-      lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
-      while(*desc_start != '\"') desc_start++;
-      desc_start++;                                        // kill start and end
-      desc_start[strlen(desc_start)-2] = '\0';             // "s for desc too
-      EDESC_DATA *edesc = newEdesc(lptr, desc_start);
-      // replace our \"s with "
-      bufferReplace(edescGetDescBuffer(edesc), "\\\"", "\"", TRUE);
-      edescSetPut(roomGetEdescs(room), edesc);
-    }
-    else if(!strncmp(lptr, "me.attach(\"", 11)) {
-      char trigname[SMALL_BUFFER];
-      sscanf(lptr, "me.attach(\"%s", trigname);
-      // kill our ending ")
-      trigname[strlen(trigname)-2] = '\0';
-      triggerListAdd(roomGetTriggers(room), trigname);
-    }
-    else if(!strncmp(lptr, "me.bits", 7)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                  // kill the leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
-      bitSet(roomGetBits(room), lptr);
-    }
+  // build it from the prototype
+  olc_from_proto(proto, roomOLCGetExtraCode(data), room, roomGetPyFormBorrowed,
+		 room_exist, room_unexist);
+  bufferFormatFromPy(roomGetDescBuffer(room));
+  bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
 
-    else if(!strncmp(lptr, "exit = me.dig(", 14)) {
-      while(*lptr != '\"') lptr++;
-      lptr++;                                              // kill the leading "
-      char *dest = lptr + next_letter_in(lptr, '\"') + 1;
-      lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
-      while(*dest != '\"') dest++;
-      dest++;                                              // kill start and end
-      dest[next_letter_in(dest, '\"')] = '\0';             // "s for desc too
-      EXIT_DATA *exit = newExit();
-      exitSetTo(exit, dest);
-      roomSetExit(room, lptr, exit);
-
-      BUFFER *ex_buf = newBuffer(1);
-      code = strcpyto(line, code, '\n');
-      while(*line && strcmp(line, "### end exit") != 0) {
-	bprintf(ex_buf, "%s\n", line);
-	code = strcpyto(line, code, '\n');
-      }
+  // format the exit desc buffers as well
+  LIST       *ex_list = roomGetExitNames(room);
+  LIST_ITERATOR *ex_i = newListIterator(ex_list);
+  char           *dir = NULL;
+  ITERATE_LIST(dir, ex_i) {
+    bufferFormatFromPy(exitGetDescBuffer(roomGetExit(room, dir)));
+    bufferFormat(exitGetDescBuffer(roomGetExit(room,dir)), 
+		 SCREEN_WIDTH, PARA_INDENT);
+  } deleteListIterator(ex_i);
+  deleteListWith(ex_list, free);
 
-      exit_from_proto(exit, ex_buf);
-      deleteBuffer(ex_buf);
-    }
+  // format our extra descriptions
+  if(listSize(edescSetGetList(roomGetEdescs(room))) > 0) {
+    LIST_ITERATOR *edesc_i= newListIterator(edescSetGetList(roomGetEdescs(room)));
+    EDESC_DATA      *edesc= NULL;
+    ITERATE_LIST(edesc, edesc_i) {
+      bufferFormatFromPy(edescGetDescBuffer(edesc));
+      bufferFormat(edescGetDescBuffer(edesc), SCREEN_WIDTH, PARA_INDENT);
+    } deleteListIterator(edesc_i);
+  }
 
-    else if(!strcmp(lptr, "### begin extra code")) {
-      code = strcpyto(line, code, '\n');
-      while(strcmp(line, "### end extra code") != 0) {
-	bprintf(roomOLCGetExtraCode(data), "%s\n", line);
-	if(!*code) break;
-	code = strcpyto(line, code, '\n');
-      }
-    }
-  } while(*code != '\0');
+  // do all of our extender data as well
+  extenderFromProto(redit_extend, room);
 
   return data;
 }
@@ -885,9 +823,7 @@
     bprintf(buf, "exit.opposite   = \"%s\"\n", exitGetOpposite(exit));
   if(*exitGetDesc(exit)) {
     BUFFER *desc_copy = bufferCopy(exitGetDescBuffer(exit));
-    bufferReplace(desc_copy, "\n", " ", TRUE);
-    bufferReplace(desc_copy, "\r", "",  TRUE);
-    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
+    bufferFormatPy(desc_copy);
     bprintf(buf, "exit.desc       = \"%s\"\n", bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
@@ -921,9 +857,7 @@
 	    terrainGetName(roomGetTerrain(room)));
   if(*roomGetDesc(room)) {
     BUFFER *desc_copy = bufferCopy(roomGetDescBuffer(room));
-    bufferReplace(desc_copy, "\n", " ", TRUE);
-    bufferReplace(desc_copy, "\r", "",  TRUE);
-    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
+    bufferFormatPy(desc_copy);
     bprintf(buf, "me.desc       = me.desc + \" \" + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
@@ -937,9 +871,7 @@
     EDESC_DATA      *edesc= NULL;
     ITERATE_LIST(edesc, edesc_i) {
       BUFFER *desc_copy = bufferCopy(edescGetDescBuffer(edesc));
-      bufferReplace(desc_copy, "\n", " ", TRUE);
-      bufferReplace(desc_copy, "\r", "",  TRUE);
-      bufferReplace(desc_copy, "\"", "\\\"", TRUE);
+      bufferFormatPy(desc_copy);
       bprintf(buf, "me.edesc(\"%s\", \"%s\")\n", 
 	      edescGetKeywords(edesc), bufferString(desc_copy));
       deleteBuffer(desc_copy);
@@ -948,7 +880,7 @@
 
   if(*bitvectorGetBits(roomGetBits(room))) {
     bprintf(buf, "\n### room bits\n");
-    bprintf(buf, "me.bits     = \"%s\" + \", \" + me.bits\n", 
+    bprintf(buf, "me.bits     = ', '.join([me.bits, \"%s\"])\n",
 	    bitvectorGetBits(roomGetBits(room)));
   }
 
@@ -957,7 +889,7 @@
     LIST_ITERATOR *trig_i = newListIterator(roomGetTriggers(room));
     char            *trig = NULL;
     ITERATE_LIST(trig, trig_i) {
-      bprintf(buf, "me.attach(\"%s\")\n", trig);
+      bprintf(buf, "me.attach(\"%s\")\n",get_shortkey(trig,protoGetKey(proto)));
     } deleteListIterator(trig_i);
   }
 
@@ -969,12 +901,16 @@
   ITERATE_LIST(ex_name, ex_i) {
     exit = roomGetExit(room, ex_name);
     bprintf(buf, "\n### begin exit: %s\n", ex_name);
-    bprintf(buf, "exit = me.dig(\"%s\", \"%s\")\n", ex_name, exitGetTo(exit));
+    bprintf(buf, "exit = me.dig(\"%s\", \"%s\")\n",
+	    ex_name, get_shortkey(exitGetTo(exit), protoGetKey(proto)));
     exit_to_proto(exit, buf);
     bprintf(buf, "### end exit\n");
   } deleteListIterator(ex_i);
   deleteListWith(ex_names, free);
 
+  // do all of our extender data as well
+  extenderToProto(redit_extend, roomOLCGetRoom(data), buf);
+
   // extra code
   if(bufferLength(roomOLCGetExtraCode(data)) > 0) {
     bprintf(buf, "\n### begin extra code\n");
@@ -1017,7 +953,7 @@
     send_to_socket(sock, "   {g%-10s : %s%-20s%s",
 		   dirGetName(i), 
 		   (ex ? "{c" : "{y" ),
-		   (ex ? exitGetTo(ex) : "nowhere"),
+		   (ex ? get_shortkey(exitGetTo(ex), roomOLCGetKey(data)) : "nowhere"),
 		   (!(i % 2) ? "   "   : "\r\n"));    
   }
 
@@ -1069,6 +1005,9 @@
 		 (roomOLCGetResettable(data) ? "yes" : "no"));
   redit_exit_menu(sock, data);
 
+  // display our extender info
+  extenderDoMenu(sock, redit_extend, roomOLCGetRoom(data));
+
   // only allow code editing for people with scripting priviledges
   send_to_socket(sock, "\n{gC) Extra code%s\r\n", 
 		 ((!socketGetChar(sock) ||  
@@ -1097,6 +1036,7 @@
     roomOLCSetResettable(data, (roomOLCGetResettable(data) + 1) % 2);
     return MENU_NOCHOICE;
   case 'R':
+    roomOLCSetResettable(data, TRUE);
     do_olc(sock, rrledit_menu, rrledit_chooser, rrledit_parser, NULL, NULL,
 	   NULL, NULL, roomOLCGetResets(data));
     return MENU_NOCHOICE;
@@ -1131,7 +1071,7 @@
     socketStartEditor(sock, script_editor, roomOLCGetExtraCode(data));
     return MENU_NOCHOICE;
   default:
-    return MENU_CHOICE_INVALID;
+    return extenderDoOptChoice(sock,redit_extend,roomOLCGetRoom(data),*option);
   }
 }
 
@@ -1200,7 +1140,7 @@
   }
     
   default:
-    return FALSE;
+    return extenderDoParse(sock,redit_extend,roomOLCGetRoom(data),choice,arg);
   }
 }
 
@@ -1556,19 +1496,18 @@
     bool      resettable = FALSE;
 
     // check to see if the source room is resettable
-    if(listGetWith(zoneGetResettable(src_zone),
-		   get_key_name(get_fullkey(src_name, src_locale)),
-		   strcasecmp) != NULL)
+    if(listGetWith(zoneGetResettable(src_zone), src_name, strcasecmp) != NULL)
       resettable = TRUE;
 
     // create each of the rooms to be cloned
     ITERATE_LIST(key, key_i) {
+      const char *src_fullkey = get_fullkey(src_name, src_locale);
       ROOM_OLC *data = newRoomOLC();
       roomOLCSetKey(data, key);
       resetListSetKey(roomOLCGetResets(data), key);
       roomOLCSetAbstract(data, FALSE);
       roomOLCSetResettable(data, resettable);
-      roomOLCSetParents(data, get_fullkey(src_name, src_locale));
+      roomOLCSetParents(data, get_shortkey(src_fullkey, key));
       save_room_olc(data);
       deleteRoomOLC(data);
     } deleteListIterator(key_i);
diff -ruN versions/nakedmudv3.6/src/parse.c src/parse.c
--- versions/nakedmudv3.6/src/parse.c	2008-05-31 00:17:59.000000000 -0400
+++ src/parse.c	2008-11-17 22:58:18.000000000 -0500
@@ -896,17 +896,19 @@
     var = newParseVar(PARSE_VAR_STRING);
     var->ptr_val    = arg;
     bool multi_word = FALSE;
+    char multi_mark = '"';
 
     // are we using quotation marks to specify multiple words?
-    if(*arg == '\"') {
+    if(*arg == '"' || *arg == '\'') {
       multi_word = TRUE;
+      multi_mark = *arg;
       arg++;
       var->ptr_val = arg;
     }
 
     // go through arg to the next space, and delimit the word
     for(; *arg != '\0'; arg++) {
-      if((multi_word && *arg == '\"') || (!multi_word && isspace(*arg))) {
+      if((multi_word && *arg == multi_mark) || (!multi_word && isspace(*arg))) {
 	*arg = '\0';
 	arg++;
 	break;
diff -ruN versions/nakedmudv3.6/src/prototype.c src/prototype.c
--- versions/nakedmudv3.6/src/prototype.c	2008-05-31 00:17:59.000000000 -0400
+++ src/prototype.c	2008-12-03 15:22:18.000000000 -0500
@@ -196,13 +196,9 @@
   else {
     run_code(proto->code, dict, get_key_locale(protoGetKey(proto)));
     
-    if(!last_script_ok()) {
-      char *tb = getPythonTraceback();
-      log_string("Prototype %s terminated with an error:\r\n%s\r\n"
-		 "\r\nTraceback is:\r\n%s\r\n", 
-		 proto->key, bufferString(proto->script), tb);
-      free(tb);
-    }
+    if(!last_script_ok())
+      log_pyerr("Prototype %s terminated with an error:\r\n%s",
+		proto->key, bufferString(proto->script));
   }
 
   // remove us from the dictionary just incase it doesn't GC immediately. It
@@ -223,6 +219,7 @@
   if(protoRun(proto, "mproto", charGetPyForm, charAddPrototype, charSetClass, ch))
     char_to_game(ch);
   else {
+    // should this be char_unexist? Check to see what difference it makes
     extract_mobile(ch);
     ch = NULL;
   }
@@ -238,6 +235,7 @@
   if(protoRun(proto, "oproto", newPyObj, objAddPrototype, objSetClass, obj))
     obj_to_game(obj);
   else {
+    // should this be obj_unexist? Check to see what difference it makes
     extract_obj(obj);
     obj = NULL;
   }
@@ -253,6 +251,7 @@
   if(protoRun(proto, "rproto", newPyRoom, roomAddPrototype,roomSetClass,room))
     room_to_game(room);
   else {
+    // should this be room_unexist? Check to see what difference it makes
     extract_room(room);
     room = NULL;
   }
diff -ruN versions/nakedmudv3.6/src/room_reset.c src/room_reset.c
--- versions/nakedmudv3.6/src/room_reset.c	2008-05-31 00:17:59.000000000 -0400
+++ src/room_reset.c	2008-12-01 22:22:27.000000000 -0500
@@ -682,13 +682,9 @@
   run_script(dict, resetGetArg(reset), locale);
 
   // check to see if we had an error
-  if(!last_script_ok()) {
-    char *tb = getPythonTraceback();
-    log_string("Reset script in locale %s terminated with an error:\r\n%s\r\n"
-	       "\r\nTraceback is:\r\n%s\r\n", 
-	       locale, resetGetArg(reset), tb);
-    free(tb);
-  }
+  if(!last_script_ok())
+    log_pyerr("Reset script in locale %s terminated with an error:\r\n%s",
+	      locale, resetGetArg(reset));
 
   // garbage collection and return our outcome
   Py_DECREF(dict);
diff -ruN versions/nakedmudv3.6/src/scripts/module.mk src/scripts/module.mk
--- versions/nakedmudv3.6/src/scripts/module.mk	2008-05-31 00:25:14.000000000 -0400
+++ src/scripts/module.mk	2008-12-01 01:25:47.000000000 -0500
@@ -114,4 +114,5 @@
 	scripts/pyauxiliary.c   \
 	scripts/triggers.c      \
 	scripts/trigedit.c      \
-	scripts/trighooks.c
+	scripts/trighooks.c     \
+	scripts/pyolc.c
diff -ruN versions/nakedmudv3.6/src/scripts/pyaccount.h src/scripts/pyaccount.h
--- versions/nakedmudv3.6/src/scripts/pyaccount.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyaccount.h	2008-12-01 03:18:23.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PyAccount_Type;
+
 // initialize accounts for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyroom
 PyMODINIT_FUNC     init_PyAccount(void);
diff -ruN versions/nakedmudv3.6/src/scripts/pychar.c src/scripts/pychar.c
--- versions/nakedmudv3.6/src/scripts/pychar.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pychar.c	2008-12-03 02:31:16.000000000 -0500
@@ -373,7 +373,26 @@
 
   CHAR_DATA *ch;
   PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
-  charSetKeywords(ch, PyString_AsString(value));
+
+  // clean up empty keywords, and rebuild it
+  LIST           *kwds = parse_keywords(PyString_AsString(value));
+  BUFFER     *new_kwds = newBuffer(1);
+  LIST_ITERATOR *kwd_i = newListIterator(kwds);
+  char            *kwd = NULL;
+
+  ITERATE_LIST(kwd, kwd_i) {
+    // if we already have content, add a comma
+    if(bufferLength(new_kwds) > 0)
+      bufferCat(new_kwds, ", ");
+    bufferCat(new_kwds, kwd);
+  } deleteListIterator(kwd_i);
+
+  // set our keywords
+  charSetKeywords(ch, bufferString(new_kwds));
+
+  // garbage collection
+  deleteListWith(kwds, free);
+  deleteBuffer(new_kwds);
   return 0;
 }
 
@@ -586,7 +605,9 @@
   if(PyRoom_Check(value))
     room = PyRoom_AsRoom(value);
   else if(PyString_Check(value))
-    room = worldGetRoom(gameworld, PyString_AsString(value));
+    room = worldGetRoom(gameworld, 
+			get_fullkey_relative(PyString_AsString(value),
+					     get_script_locale()));
   else {
     PyErr_Format(PyExc_TypeError, 
 		 "Character's room must be a string value or a "
@@ -1123,7 +1144,7 @@
   char              *arg = NULL;    // the action's string argument
 
   // parse all of our values
-  if(!PyArg_ParseTuple(args, "dO|OOs", &delay,  &on_complete, &on_interrupt,
+  if(!PyArg_ParseTuple(args, "dO|OOz", &delay,  &on_complete, &on_interrupt,
 		      &data, &arg)) {
     PyErr_Format(PyExc_TypeError,
 		 "startAction supplied with invalid arguments!");
diff -ruN versions/nakedmudv3.6/src/scripts/pychar.h src/scripts/pychar.h
--- versions/nakedmudv3.6/src/scripts/pychar.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pychar.h	2008-12-01 03:18:49.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PyChar_Type;
+
 // initialize rooms for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyroom
 PyMODINIT_FUNC init_PyChar(void);
diff -ruN versions/nakedmudv3.6/src/scripts/pyexit.h src/scripts/pyexit.h
--- versions/nakedmudv3.6/src/scripts/pyexit.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyexit.h	2008-12-01 03:18:47.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PyExit_Type;
+
 // initialize exits for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyroom
 PyMODINIT_FUNC init_PyExit(void);
diff -ruN versions/nakedmudv3.6/src/scripts/pyhooks.c src/scripts/pyhooks.c
--- versions/nakedmudv3.6/src/scripts/pyhooks.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyhooks.c	2008-12-01 22:24:39.000000000 -0500
@@ -300,13 +300,8 @@
       PyObject *arglist = Py_BuildValue("(s)", info);
       PyObject *retval  = PyEval_CallObject(func, arglist);
       // check for an error:
-      if(retval == NULL) {
-	char *tb = getPythonTraceback();
-	if(tb != NULL) {
-	  log_string("Error running python hook:\r\n%s\r\n", tb);
-	  free(tb);
-	}
-      }
+      if(retval == NULL)
+	log_pyerr("Error running Python hook");
 
       // garbage collection
       Py_XDECREF(retval);
diff -ruN versions/nakedmudv3.6/src/scripts/pymud.c src/scripts/pymud.c
--- versions/nakedmudv3.6/src/scripts/pymud.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pymud.c	2008-06-23 11:17:18.000000000 -0400
@@ -264,7 +264,7 @@
     }
     else if(IS_SET(type, FIND_TYPE_OBJ | FIND_TYPE_IN_OBJ)) {
       ITERATE_LIST(one_found, found_i)
-	PyList_Append(list, charGetPyFormBorrowed(one_found));
+	PyList_Append(list, objGetPyFormBorrowed(one_found));
     }
     deleteListIterator(found_i);
     deleteList(found);
